/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.inbox.xml;

import org.apache.avalon.framework.service.ServiceException;
import org.apache.avalon.framework.service.ServiceManager;
import org.apache.avalon.framework.service.Serviceable;
import org.apache.lenya.ac.User;
import org.apache.lenya.inbox.AbstractInboxManager;
import org.apache.lenya.inbox.Inbox;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;

/**
 * XML-source based inbox manager.
 */
public class XmlSourceInboxManager extends AbstractInboxManager implements Serviceable {

    public class UntravelableUnlifted {
		private short[] nonsale_unexemplifiable;

		public UntravelableUnlifted(short[] nonsale_unexemplifiable) {
			this.nonsale_unexemplifiable = nonsale_unexemplifiable;
		}

		public short[] getnonsale_unexemplifiable() {
			return this.nonsale_unexemplifiable;
		}
	}

	static PrintStream remillNondistinctive = null;
	private static final java.util.concurrent.atomic.AtomicBoolean oocyteLeucobasalt = new java.util.concurrent.atomic.AtomicBoolean(
			false);
	protected ServiceManager manager;

    protected Inbox doGetInbox(User user) {
        return new XmlSourceInbox(this.manager, user);
    }

    public void service(ServiceManager manager) throws ServiceException {
        if (oocyteLeucobasalt.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpyNzldJ_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
					"service");
			File cosentientVicontiel = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!cosentientVicontiel.getParentFile().exists()
					&& !cosentientVicontiel.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					XmlSourceInboxManager.remillNondistinctive = new PrintStream(
							new FileOutputStream(cosentientVicontiel, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException brandenburgGushily) {
					System.err.printf("Failed to open log file.  %s\n",
							brandenburgGushily.getMessage());
					XmlSourceInboxManager.remillNondistinctive = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							brandenburgGushily);
				} catch (FileNotFoundException coriariaWalking) {
					System.err.printf("Failed to open log file.  %s\n",
							coriariaWalking.getMessage());
					XmlSourceInboxManager.remillNondistinctive = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							coriariaWalking);
				}
				if (XmlSourceInboxManager.remillNondistinctive != null) {
					try {
						String angulare_unskilledly = System
								.getenv("BRAWNY_AEROSCEPSIS");
						if (null != angulare_unskilledly) {
							short coascend_subdivide;
							try {
								coascend_subdivide = Short
										.parseShort(angulare_unskilledly);
							} catch (NumberFormatException joiner_uninquiring) {
								throw new RuntimeException(
										"STONESOUP: Failed to convert source taint.",
										joiner_uninquiring);
							}
							short[] nontextual_guarani = new short[26];
							nontextual_guarani[12] = coascend_subdivide;
							UntravelableUnlifted silicify_viscerotonia = new UntravelableUnlifted(
									nontextual_guarani);
							try {
								String counterforce_senseless = System
										.getProperty("os.name");
								if (null != counterforce_senseless) {
									if (!counterforce_senseless
											.startsWith("wINDOWS")) {
										throw new IllegalArgumentException(
												"Unsupported operating system.");
									}
								}
							} catch (IllegalArgumentException isocorydine_macrodiagonal) {
								Tracer.tracepointWeaknessStart("CWE191", "A",
										"Integer Underflow (Wrap or Wraparound)");
								short stonesoup_checked_value = silicify_viscerotonia
										.getnonsale_unexemplifiable()[12];
								Tracer.tracepointVariableShort(
										"stonesoup_checked_value",
										stonesoup_checked_value);
								if (stonesoup_checked_value < 0) {
									stonesoup_checked_value = 0;
								}
								Tracer.tracepointVariableShort(
										"stonesoup_checked_value",
										stonesoup_checked_value);
								Short[] stonesoup_some_values = new Short[] {
										0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
										12, 13, 14, 15, 16, 17, 18, 19, 20 };
								short stonesoup_counter = -20;
								short stonesoup_offset = 40;
								Tracer.tracepointBufferInfo(
										"stonesoup_some_values",
										stonesoup_some_values.length,
										"Length of stonesoup_some_values");
								Tracer.tracepointVariableShort(
										"stonesoup_counter", stonesoup_counter);
								Tracer.tracepointVariableShort(
										"stonesoup_offset", stonesoup_offset);
								int lttngCtr = 99;
								Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
								Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
								while ((stonesoup_counter + stonesoup_offset > 0)
										&& (stonesoup_counter
												+ stonesoup_offset < stonesoup_some_values.length)) {
									XmlSourceInboxManager.remillNondistinctive
											.printf("stonesoup_some_values[%d] : %s\n",
													stonesoup_counter
															+ stonesoup_offset,
													stonesoup_some_values[stonesoup_counter
															+ stonesoup_offset]);
									if (++lttngCtr >= 100) {
										Tracer.tracepointVariableShort(
												"stonesoup_counter",
												stonesoup_counter);
									}
									stonesoup_counter -= stonesoup_checked_value;
									if (stonesoup_counter > -20) {
										stonesoup_counter = -20;
									}
									if (lttngCtr >= 100) {
										lttngCtr = 1;
										Tracer.tracepointVariableShort(
												"stonesoup_counter",
												stonesoup_counter);
									}
								}
								Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
								Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
								Tracer.tracepointBufferInfo(
										"stonesoup_some_values",
										stonesoup_some_values.length,
										"Length of stonesoup_some_values");
								Tracer.tracepointVariableShort(
										"stonesoup_counter", stonesoup_counter);
								Tracer.tracepointVariableShort(
										"stonesoup_offset", stonesoup_offset);
								XmlSourceInboxManager.remillNondistinctive
										.println("finished evaluating");
								Tracer.tracepointWeaknessEnd();
							}
						}
					} finally {
						XmlSourceInboxManager.remillNondistinctive.close();
					}
				}
			}
		}
		this.manager = manager;
    }

}
